// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/* eslint-disable @typescript-eslint/no-explicit-any */
import { Query } from "../../../src/core/query/Query";
import { QueryHandler } from "../../../src/core/decorator/QueryHandlerDecorator";
export class ConcreteQueryResponse {
    payload;
    constructor(payload) {
        this.payload = payload;
    }
}
export class ConcreteQuery extends Query {
    itemId;
    payload;
    constructor(itemId, payload) {
        super();
        this.itemId = itemId;
        this.payload = payload;
    }
}
export class ConcreteQueryRepository {
    map = new Map();
}
let ConcreteQueryHandler = class ConcreteQueryHandler {
    repo;
    constructor(repo = new ConcreteQueryRepository()) {
        this.repo = repo;
    }
    execute(query) {
        this.repo.map.set(query, "Hello world");
        return Promise.resolve(new ConcreteQueryResponse(query.payload));
    }
};
ConcreteQueryHandler = __decorate([
    QueryHandler(ConcreteQuery),
    __metadata("design:paramtypes", [ConcreteQueryRepository])
], ConcreteQueryHandler);
export { ConcreteQueryHandler };
